<!DOCTYPE html>
<html>
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
  <!-- Popper Development version -->
  <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- Import Datatable sau jquery -->
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <link rel="stylesheet" href="style.css">
</head>
<body>
    <div class="container-fluid">
        <div class="row text-primary text-center mt-2">
            <div class="col-sm-6">
                <h4 class="font-weight-bold">Weather App</h4>
            </div>
            <div class="col-sm-3 text-right mt-1">
                <h5><a href="Task JR3.html">Current</a></h5>
            </div>
            <div class="col-sm-3 text-left mt-1">
                <h5><a href="Forecast.html">Forecast</a></h5>
            </div>
        </div>
    </div>

    <div class="container-fluid bg-primary text-white">
        <div class="row text-center pt-5 pb-5">
            <div class="col-sm-12 pt-3 pb-3">
                <h1>Get Current Weather Information</h1>
            </div>
        </div>
    </div>

    <div class="container-fluid">
        <div class="row text-center mt-3">
            <div class="col-sm-12 text-primary">
                <h4>Enter City Name</h4>
            </div>
        </div>
        <div class="row text-center mt-3">
            <div class="col-sm-4"></div>
            <div class="col-sm-7">
                <div class="row">
                    <div class="col-md-3">
                        <input id="inp-city-name" class="form-control" type="text" placeholder="Enter city name">
                    </div>
                    <div class="col-md-3">
                        <input id="inp-next-day" class="form-control" type="text" placeholder="Next day: Min - 1 & Max - 16">
                    </div>
                    <div class="col-md-6 text-left">
                        <button class="btn btn-primary text-white" id="btn-search">Search City</button>
                    </div>
                </div>
            </div>
            <div class="col-sm-3"></div>
        </div>
    </div>

    <div class="container-fluid">
        <div class="row mt-4 text-center">
            <div class="col-sm-12 mt-4">
                <h2>Weather forecast for <span id="span-city"></span></h2>
            </div>
        </div>
        <div class="row mt-4 text-center">
            <div class="col-sm-12">
                <table class="table table-bordered table-striped table-hover" id="table">
                    <thead class="bg-primary text-white">
                        <tr>
                            <th>Next day</th>
                            <th>Icon</th>
                            <th>Weather</th>
                            <th>Description</th>
                            <th>Morning Temperature</th>
                            <th>Night Temperature</th>
                            <th>Min. Temperature</th>
                            <th>Max. Temperature</th>
                            <th>Pressure</th>
                            <th>Humidity</th>
                            <th>Wind Speed</th>
                            <th>Wind Direction</th>
                        </tr>
                    </thead>
                </table>
            </div>
        </div>
    </div>

    <footer>
        <div class="container-fluid bg-primary fixed-bottom">
            <div class="row text-center text-white pt-4 pb-3">
                <div class="col-sm-12">
                    <h5>Copyright <i class="far fa-copyright"></i> Weather App</h5>
                </div>
            </div>
        </div>
    </footer>
</body>
<script>
    "use strict"
    const gBASE_URL = 'http://api.openweathermap.org/data/2.5/forecast/daily?q=';
    const gTABLE_ROW = [
        "cnt",
        "icon",
        "weather",
        "description",
        "morn",
        "night",
        "min",
        "max",
        "pressure",
        "humidity",
        "speed",
        "deg"];
    var gArrData = [];
    const gCNT = 0;
    const gICON = 1;
    const gWEATHER = 2;
    const gDESCRIPTION = 3;
    const gMORNING = 4;
    const gNIGHT = 5;
    const gMIN = 6;
    const gMAX = 7;
    const gPRESSURE = 8;
    const gHUMIDITY = 9;
    const gSPEED = 10;
    const gDIRECTION = 11;
    var gDataTable = $("#table").DataTable({
        columns: [
            {data: gTABLE_ROW[gCNT]},
            {data: gTABLE_ROW[gICON]},
            {data: gTABLE_ROW[gWEATHER]},
            {data: gTABLE_ROW[gDESCRIPTION]},
            {data: gTABLE_ROW[gMORNING]},
            {data: gTABLE_ROW[gNIGHT]},
            {data: gTABLE_ROW[gMIN]},
            {data: gTABLE_ROW[gMAX]},
            {data: gTABLE_ROW[gPRESSURE]},
            {data: gTABLE_ROW[gHUMIDITY]},
            {data: gTABLE_ROW[gSPEED]},
            {data: gTABLE_ROW[gDIRECTION]}
        ],
        columnDefs: [
            {
                targets: gICON,
                render: function(data) {
                    return '<img src="' + data + '">'
                }
            }
        ]
    })
    $(document).ready(function() {
        $("#btn-search").on("click", function() {
            onBtnSearchClick();
        });
    });
    function onBtnSearchClick() {
        var vCityName = $("#inp-city-name").val();
        var vNextDay = $("#inp-next-day").val();
        var vCheck = validateData(vCityName, vNextDay);
        if(vCheck) {
            console.log(vCityName);
            console.log(vNextDay);
            callApiGetForecast(vCityName, vNextDay);
        }
    }
    function validateData(paramCity, paramDay) {
        if(paramCity === "") {
            alert("Vui lòng điền City name !");
            return false;
        }
        if(isNaN(paramDay)) {
            alert("Next day điền vào phải là số !");
            return false;
        }
        if(paramDay < 1 || paramDay > 16) {
            alert("Next day nhập vào tối thiểu là 1, tối đa là 16 !!");
            return false;
        }
        return true;    
    }
    function callApiGetForecast(paramCity, paramDay) {
        $.ajax({
            url: gBASE_URL + paramCity + "&units=metric&cnt=" + paramDay + "&APPID=c10bb3bd22f90d636baa008b1529ee25",
            type: "GET",
            dataType: "json",
            success: function(data) {
                console.log(data);
                displayData(data);
            },
            error: function(error) {
                alert(error.responseText);
            }
        })
    }
    function displayData(paramData) {
        $("#span-city").html(paramData.city.name);
        for (var i = 0; i < paramData.list.length; i++) {
            var vObjData = {
                cnt: paramData.cnt,
                icon: "http://openweathermap.org/img/w/" + paramData.list[i].weather[0].icon + ".png",
                weather: paramData.list[i].weather[0].main,
                description: paramData.list[i].weather[0].description,
                morn: paramData.list[i].temp.morn,
                night: paramData.list[i].temp.night,
                min: paramData.list[i].temp.min,
                max: paramData.list[i].temp.max,
                pressure: paramData.list[i].pressure,
                humidity: paramData.list[i].humidity,
                speed: paramData.list[i].speed,
                deg: paramData.list[i].deg
            }
            gArrData.push(vObjData);
        }
        loadDataToTable(gArrData);
    }
    function loadDataToTable(paramData) {
        gDataTable.clear();
        gDataTable.rows.add(paramData);
        gDataTable.draw();
    }
</script>
</html>